/* The following code was generated by JFlex 1.4.3 on 13/12/11 19:22 */

/**
 * Copyright (c) 2009-2011 Sindice Limited. All Rights Reserved.
 *
 * Project and contact information: http://www.siren.sindice.com/
 *
 * This file is part of the SIREn project.
 *
 * SIREn is a free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of
 * the License, or (at your option) any later version.
 *
 * SIREn is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public
 * License along with SIREn. If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * @project solr-plugins
 * @author Renaud Delbru [ 25 Jul 2010 ]
 * @link http://renaud.delbru.fr/
 * @copyright Copyright (C) 2010 by Renaud Delbru, All rights reserved.
 */
package org.sindice.siren.qparser.analysis;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.lucene.analysis.Token;
import java_cup.runtime.*;
import org.sindice.siren.util.XSDDatatype;
import org.sindice.siren.qparser.tuple.CellValue;


/**
 * This class is a scanner generated by 
 * <a href="http://www.jflex.de/">JFlex</a> 1.4.3
 * on 13/12/11 19:22 from the specification file
 * <tt>/home/renaud/Work/Sindice/workspace/siren/siren.git/target/checkout/siren-qparser/src/main/jflex/NTripleQueryTokenizerImpl.flex</tt>
 */
public final class NTripleQueryTokenizerImpl {

  /** This character denotes the end of file */
  public static final int YYEOF = -1;

  /** initial size of the lookahead buffer */
  private static final int ZZ_BUFFERSIZE = 16384;

  /** lexical states */
  public static final int LITPATSTR = 4;
  public static final int YYINITIAL = 0;
  public static final int LITSTR = 2;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = { 
     0,  0,  1,  1,  2, 2
  };

  /** 
   * Translates characters to character classes
   */
  private static final String ZZ_CMAP_PACKED = 
    "\11\0\1\3\1\2\1\0\1\3\1\1\22\0\1\3\1\0\1\22"+
    "\3\0\1\11\1\23\1\17\1\20\1\21\2\0\1\16\16\0\1\4"+
    "\1\0\1\5\2\0\1\6\2\0\1\10\11\0\1\7\1\12\2\0"+
    "\1\13\1\0\1\15\7\0\1\25\1\0\1\24\35\0\1\14\uff83\0";

  /** 
   * Translates characters to character classes
   */
  private static final char [] ZZ_CMAP = zzUnpackCMap(ZZ_CMAP_PACKED);

  /** 
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\3\0\1\1\2\2\6\1\1\3\1\4\1\5\1\6"+
    "\1\7\1\10\1\11\1\12\1\0\1\11\1\13\4\0"+
    "\1\14\1\15\1\0\1\11\1\16\1\0\1\17\1\20"+
    "\6\0\1\21\1\22";

  private static int [] zzUnpackAction() {
    int [] result = new int[43];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** 
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\26\0\54\0\102\0\130\0\102\0\156\0\204"+
    "\0\232\0\260\0\306\0\334\0\102\0\102\0\102\0\102"+
    "\0\102\0\102\0\362\0\u0108\0\u011e\0\u0134\0\u014a\0\u0160"+
    "\0\u0176\0\u018c\0\u01a2\0\102\0\102\0\u01b8\0\102\0\102"+
    "\0\u01ce\0\102\0\102\0\u01e4\0\u01fa\0\u0210\0\u0226\0\u023c"+
    "\0\u0252\0\102\0\102";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[43];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /** 
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\1\4\1\5\2\6\1\7\1\4\1\10\1\11\1\4"+
    "\1\12\1\13\1\4\1\14\1\4\1\15\1\16\1\17"+
    "\1\20\1\21\1\22\2\4\22\23\1\24\2\23\1\25"+
    "\23\26\1\27\1\26\1\30\30\0\1\6\23\0\5\31"+
    "\1\0\20\31\7\0\1\32\30\0\1\33\24\0\1\34"+
    "\27\0\1\35\26\0\1\35\11\0\22\23\1\0\2\23"+
    "\25\0\1\36\1\0\2\37\1\0\17\37\1\40\3\37"+
    "\23\26\1\0\1\26\25\0\1\41\1\0\2\37\1\0"+
    "\20\37\1\42\2\37\5\31\1\43\20\31\10\0\1\34"+
    "\32\0\1\15\34\0\1\44\25\0\1\45\5\0\1\46"+
    "\25\0\1\47\21\0\5\50\1\0\20\50\5\51\1\0"+
    "\20\51\5\50\1\52\20\50\5\51\1\53\20\51";

  private static int [] zzUnpackTrans() {
    int [] result = new int[616];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /* error codes */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  private static final int ZZ_NO_MATCH = 1;
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /* error messages for the codes above */
  private static final String ZZ_ERROR_MSG[] = {
    "Unkown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state <code>aState</code>
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\3\0\1\11\1\1\1\11\6\1\6\11\2\1\1\0"+
    "\2\1\4\0\2\11\1\0\2\11\1\0\2\11\6\0"+
    "\2\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[43];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** the input device */
  private java.io.Reader zzReader;

  /** the current state of the DFA */
  private int zzState;

  /** the current lexical state */
  private int zzLexicalState = YYINITIAL;

  /** this buffer contains the current text to be matched and is
      the source of the yytext() string */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** the textposition at the last accepting state */
  private int zzMarkedPos;

  /** the current text position in the buffer */
  private int zzCurrentPos;

  /** startRead marks the beginning of the yytext() string in the buffer */
  private int zzStartRead;

  /** endRead marks the last character in the buffer, that has been read
      from input */
  private int zzEndRead;

  /** number of newlines encountered up to the start of the matched text */
  private int yyline;

  /** the number of characters up to the start of the matched text */
  private int yychar;

  /**
   * the number of characters from the last newline up to the start of the 
   * matched text
   */
  private int yycolumn;

  /** 
   * zzAtBOL == true <=> the scanner is currently at the beginning of a line
   */
  private boolean zzAtBOL = true;

  /** zzAtEOF == true <=> the scanner is at the EOF */
  private boolean zzAtEOF;

  /** denotes if the user-EOF-code has already been executed */
  private boolean zzEOFDone;

  /* user code: */

  public static final int EOF 	      = NTripleQueryTokenizer.EOF;
  public static final int ERROR       = NTripleQueryTokenizer.ERROR;
  public static final int AND 	      = NTripleQueryTokenizer.AND;
  public static final int OR 		      = NTripleQueryTokenizer.OR;
  public static final int MINUS       = NTripleQueryTokenizer.MINUS;
  public static final int LPAREN      = NTripleQueryTokenizer.LPAREN;
  public static final int RPAREN      = NTripleQueryTokenizer.RPAREN;
  public static final int URIPATTERN  = NTripleQueryTokenizer.URIPATTERN;
  public static final int LITERAL     = NTripleQueryTokenizer.LITERAL;
  public static final int LPATTERN    = NTripleQueryTokenizer.LPATTERN;
  public static final int WILDCARD    = NTripleQueryTokenizer.WILDCARD;
	
	public static final String[] TOKEN_TYPES = new String[] {
	    "<EOF>",
	    "<ERROR>",
	    "<AND>",
	    "<OR>",
	    "<MINUS>",
	    "<LPAREN>",
	    "<RPAREN>",
	    "<WILDCARD>",
	    "<URIPATTERN>",
	    "<LITERAL>",
	    "<LPATTERN>"
	};

	private static final
	Logger logger = LoggerFactory.getLogger(NTripleQueryTokenizerImpl.class);
	
	private final StringBuffer buffer = new StringBuffer();
	private final StringBuffer metadataBuffer = new StringBuffer();
  
  /** Datatype representing xsd:string */
  private static final char[] XSD_STRING = XSDDatatype.XSD_STRING.toCharArray();
  
	public final int yychar()	{
		return yychar;
	}
  
	/** 
	 * To create a new java_cup.runtime.Symbol with information about
	 * the current token, the token will have no value in this case.
	 */
	private Symbol symbol(int type) {
		logger.debug("Obtain token {}", type);
	  return new Symbol(type, yyline, yycolumn);
	}
	
	/**
	 * Creates a new java_cup.runtime.Symbol with information
	 * about the current token, but this object has a value.
	 */
	private Symbol symbol(int type, String value) {
		logger.debug("Obtain token {} \"{}\"", type, value);
	  return new Symbol(type, yyline, yycolumn, value);
	}
	
	private Symbol symbol(int type, CellValue dl) {
	logger.debug("Obtain token {} \"{}\"", type, dl);
    return new Symbol(type, yyline, yycolumn, dl);
	}
	
	/**
	 * Fills Lucene token with the current token text, removing the first and 
	 * last characters.
	 */
	final String getURIText() {
	  return new String(zzBuffer, zzStartRead + 1, zzMarkedPos - zzStartRead - 2);
	}

	/**
	 * Fills Lucene token with the current token text, removing the first and 
	 * last characters.
	 */
	final void getURIText(Token t) {
	  t.setTermBuffer(zzBuffer, zzStartRead + 1, zzMarkedPos - zzStartRead - 2);
	}
	
	/**
	 * Return the current string buffer.
	 */
	final String getLiteralText() {
		return new String(buffer);
	}
	
	/**
	 * Fills Lucene token with the current string buffer.
	 */
	final void getLiteralText(Token t) {
    char[] chars = new char[buffer.length()];
    buffer.getChars(0, buffer.length(), chars, 0);
	  t.setTermBuffer(chars, 0, chars.length);
	}
	
	/**
   * Return the datatype URI.
   *
   * <p> Return the datatype xsd:string by default.
   */
  public final char[] getDatatypeURI() {
    // If not datatype, returns by default datatype xsd:string
    if (metadataBuffer.length() == 0) {
      return XSD_STRING;
    }
    char[] chars = new char[metadataBuffer.length()];
    metadataBuffer.getChars(0, metadataBuffer.length(), chars, 0);
    return chars;
  }
	


  /**
   * Creates a new scanner
   * There is also a java.io.InputStream version of this constructor.
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public NTripleQueryTokenizerImpl(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Creates a new scanner.
   * There is also java.io.Reader version of this constructor.
   *
   * @param   in  the java.io.Inputstream to read input from.
   */
  public NTripleQueryTokenizerImpl(java.io.InputStream in) {
    this(new java.io.InputStreamReader(in));
  }

  /** 
   * Unpacks the compressed character translation table.
   *
   * @param packed   the packed character translation table
   * @return         the unpacked character translation table
   */
  private static char [] zzUnpackCMap(String packed) {
    char [] map = new char[0x10000];
    int i = 0;  /* index in packed string  */
    int j = 0;  /* index in unpacked array */
    while (i < 80) {
      int  count = packed.charAt(i++);
      char value = packed.charAt(i++);
      do map[j++] = value; while (--count > 0);
    }
    return map;
  }


  /**
   * Refills the input buffer.
   *
   * @return      <code>false</code>, iff there was new input.
   * 
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead-zzStartRead);

      /* translate stored positions */
      zzEndRead-= zzStartRead;
      zzCurrentPos-= zzStartRead;
      zzMarkedPos-= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzCurrentPos*2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
    }

    /* finally: fill the buffer with new input */
    int numRead = zzReader.read(zzBuffer, zzEndRead,
                                            zzBuffer.length-zzEndRead);

    if (numRead > 0) {
      zzEndRead+= numRead;
      return false;
    }
    // unlikely but not impossible: read 0 characters, but not at end of stream    
    if (numRead == 0) {
      int c = zzReader.read();
      if (c == -1) {
        return true;
      } else {
        zzBuffer[zzEndRead++] = (char) c;
        return false;
      }     
    }

	// numRead < 0
    return true;
  }

    
  /**
   * Closes the input stream.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true;            /* indicate end of file */
    zzEndRead = zzStartRead;  /* invalidate buffer    */

    if (zzReader != null)
      zzReader.close();
  }


  /**
   * Resets the scanner to read from a new input stream.
   * Does not close the old reader.
   *
   * All internal variables are reset, the old input stream 
   * <b>cannot</b> be reused (internal buffer is discarded and lost).
   * Lexical state is set to <tt>ZZ_INITIAL</tt>.
   *
   * @param reader   the new input stream 
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzAtBOL  = true;
    zzAtEOF  = false;
    zzEOFDone = false;
    zzEndRead = zzStartRead = 0;
    zzCurrentPos = zzMarkedPos = 0;
    yyline = yychar = yycolumn = 0;
    zzLexicalState = YYINITIAL;
  }


  /**
   * Returns the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   */
  public final String yytext() {
    return new String( zzBuffer, zzStartRead, zzMarkedPos-zzStartRead );
  }


  /**
   * Returns the character at position <tt>pos</tt> from the 
   * matched text. 
   * 
   * It is equivalent to yytext().charAt(pos), but faster
   *
   * @param pos the position of the character to fetch. 
   *            A value from 0 to yylength()-1.
   *
   * @return the character at position pos
   */
  public final char yycharat(int pos) {
    return zzBuffer[zzStartRead+pos];
  }


  /**
   * Returns the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occured while scanning.
   *
   * In a wellformed scanner (no or only correct usage of 
   * yypushback(int) and a match-all fallback rule) this method 
   * will only be called with things that "Can't Possibly Happen".
   * If this method is called, something is seriously wrong
   * (e.g. a JFlex bug producing a faulty scanner etc.).
   *
   * Usual syntax/scanner level error handling should be done
   * in error fallback rules.
   *
   * @param   errorCode  the code of the errormessage to display
   */
  private void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    }
    catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  } 


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * They will be read again by then next call of the scanning method
   *
   * @param number  the number of characters to be read again.
   *                This number must not be greater than yylength()!
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


  /**
   * Resumes scanning until the next regular expression is matched,
   * the end of input is encountered or an I/O-Error occurs.
   *
   * @return      the next token
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  public int getNextToken() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char [] zzBufferL = zzBuffer;
    char [] zzCMapL = ZZ_CMAP;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      for (zzCurrentPosL = zzStartRead; zzCurrentPosL < zzMarkedPosL;
                                                             zzCurrentPosL++) {
        switch (zzBufferL[zzCurrentPosL]) {
        case '\u000B':
        case '\u000C':
        case '\u0085':
        case '\u2028':
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn++;
        }
      }

      if (zzR) {
        // peek one character ahead if it is \n (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof) 
            zzPeek = false;
          else 
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;
  
      zzState = ZZ_LEXSTATE[zzLexicalState];


      zzForAction: {
        while (true) {
    
          if (zzCurrentPosL < zzEndReadL)
            zzInput = zzBufferL[zzCurrentPosL++];
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = zzBufferL[zzCurrentPosL++];
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMapL[zzInput] ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          int zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
        case 11: 
          { yybegin(YYINITIAL); return LPATTERN;
          }
        case 19: break;
        case 17: 
          { yybegin(YYINITIAL);
                    // remove the first four and the last characters.
                    metadataBuffer.append(zzBuffer, zzStartRead + 4, zzMarkedPos - zzStartRead - 5);
                    return LITERAL;
          }
        case 20: break;
        case 15: 
          { buffer.append("\'");
          }
        case 21: break;
        case 7: 
          { buffer.setLength(0);
	                  metadataBuffer.setLength(0);
	                  yybegin(LITSTR);
          }
        case 22: break;
        case 3: 
          { return MINUS;
          }
        case 23: break;
        case 8: 
          { buffer.setLength(0);
	                  metadataBuffer.setLength(0);
	                  yybegin(LITPATSTR);
          }
        case 24: break;
        case 6: 
          { return WILDCARD;
          }
        case 25: break;
        case 14: 
          { buffer.append("\"");
          }
        case 26: break;
        case 12: 
          { return AND;
          }
        case 27: break;
        case 4: 
          { return LPAREN;
          }
        case 28: break;
        case 18: 
          { yybegin(YYINITIAL);
                    // remove the first four and the last characters.
                    metadataBuffer.append(zzBuffer, zzStartRead + 4, zzMarkedPos - zzStartRead - 5);
                    return LPATTERN;
          }
        case 29: break;
        case 5: 
          { return RPAREN;
          }
        case 30: break;
        case 13: 
          { return OR;
          }
        case 31: break;
        case 10: 
          { yybegin(YYINITIAL); return LITERAL;
          }
        case 32: break;
        case 16: 
          { // Assign the xsd:anyURI
                    metadataBuffer.setLength(0);
                    metadataBuffer.append(XSDDatatype.XSD_ANY_URI);
	                  return URIPATTERN;
          }
        case 33: break;
        case 1: 
          { return ERROR;
          }
        case 34: break;
        case 9: 
          { buffer.append(yytext());
          }
        case 35: break;
        case 2: 
          { /* ignore */
          }
        case 36: break;
        default: 
          if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
            zzAtEOF = true;
            switch (zzLexicalState) {
            case LITPATSTR: {
              return ERROR;
            }
            case 44: break;
            case YYINITIAL: {
              return EOF;
            }
            case 45: break;
            case LITSTR: {
              return ERROR;
            }
            case 46: break;
            default:
            return YYEOF;
            }
          } 
          else {
            zzScanError(ZZ_NO_MATCH);
          }
      }
    }
  }


}
